/************************************************************************************/
/*  Program name CAPFAIMP_INVMISS_REP_ITF.sql                                      	*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 18 JAN, 2006   NIP Karen         First created                               	*/
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAIMP_INVMISS_REP_ITF';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_FA_INVMISS_REP_ITF;
	

BEGIN
	UPDATE
		FA_INVMISS_REP_ITF
	SET	
		INVENTORY_NAME	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(INVENTORY_NAME,1,4), INVENTORY_NAME),
		ASSET_NUMBER	=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(ASSET_NUMBER,1,4), ASSET_NUMBER),
		TAG_NUMBER		=	CAPBRIMP_MAPPING.RenameStr(SUBSTR(TAG_NUMBER,1,4), TAG_NUMBER)
	WHERE ASSET_NUMBER IN
		(
		SELECT 
			ASSET_NUMBER
		FROM 
			CRST_FA_INVMISS_REP_ITF
		);
	
	FOR C1 IN Cur_F LOOP
		BEGIN		
			INSERT INTO FA_INVMISS_REP_ITF
			VALUES
			(
			C1.REQUEST_ID,
			C1.INVENTORY_NAME,
			C1.LOCATION,
			C1.CATEGORY,
			C1.ASSET_KEY,
			C1.ASSET_NUMBER,
			C1.DESCRIPTION,
			C1.UNITS_ASSIGNED,
			C1.SERIAL_NUMBER,
			C1.TAG_NUMBER,
			C1.MANUFACTURER_NAME,
			C1.MODEL_NUMBER,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.LAST_UPDATE_DATE,
			C1.LAST_UPDATE_LOGIN,
			C1.INVENTORIAL
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/